// Tanks for the TI-89
// by Andy Dufilie
// http://pages.cthome.net/pdufilie/
//
// If you use any code from this source in your released work,
// please make your source public so others can learn from it.

#define SAVE_SCREEN
#include <all.h>

#define HUMAN 0
#define AI 1

int x0 = 0, y0 = 0, top = 24, turn = -1, weapon = 1, wind = 0, round = 0;
int tankx[2] = {0, 0}, tanky[2] = {0, 0}, angle[2] = {0, 0}, power[2] = {0, 0}, max[2] = {0, 0}, prev[2] = {0, 0}, shield[2] = {0, 0}, credits[2] = {0, 0}, frags[2] = {0, 0};
int players = 1, skill = 1, gamemode = 1, windmode = 2, limit = 5, type = 1;
int ai_dx = 0, ai_dy = 0, ai_power = 0, ai_want = 0;
int land[160] = {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
int key[10] = {0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, repeat = 0, bubble = 0;

int circles[5][10] = {
  { 2,  1,  0,  0,  0,  0,  0,  0,  0,  0},
  { 4,  3,  3,  1,  0,  0,  0,  0,  0,  0},
  { 6,  5,  5,  4,  3,  1,  0,  0,  0,  0},
  { 8,  8,  7,  7,  6,  5,  4,  2,  0,  0},
  {10, 10,  9,  9,  8,  8,  7,  6,  4,  2}
};

/*
int circles[5][13] = {
  { 3,  2,  1,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0},
  { 5,  4,  4,  3,  1,  0,  0,  0,  0,  0,  0,  0,  0},
  { 7,  7,  6,  6,  5,  4,  2,  0,  0,  0,  0,  0,  0},
  { 9,  9,  8,  8,  7,  7,  6,  4,  2,  0,  0,  0,  0},
  {11, 11, 10, 10, 10,  9,  8,  7,  6,  5,  2,  0,  0}
};

int circles[5][13] = {
  { 3,  2,  1,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0},
  { 6,  5,  5,  4,  3,  1,  0,  0,  0,  0,  0,  0,  0},
  { 8,  8,  7,  7,  6,  5,  4,  2,  0,  0,  0,  0,  0},
  {11, 11, 10, 10, 10,  9,  8,  7,  6,  5,  2,  0,  0},
  {13, 13, 12, 12, 12, 11, 11, 10,  9,  8,  7,  5,  2}
};
*/

/*
  { 2,  1,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0}
  { 3,  2,  1,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0}
  { 4,  3,  3,  1,  0,  0,  0,  0,  0,  0,  0,  0,  0}
  { 5,  4,  4,  3,  1,  0,  0,  0,  0,  0,  0,  0,  0}
  { 6,  5,  5,  4,  3,  1,  0,  0,  0,  0,  0,  0,  0}
  { 7,  7,  6,  6,  5,  4,  2,  0,  0,  0,  0,  0,  0}
  { 8,  8,  7,  7,  6,  5,  4,  2,  0,  0,  0,  0,  0}
  { 9,  9,  8,  8,  7,  7,  6,  4,  2,  0,  0,  0,  0}
  {10, 10,  9,  9,  8,  8,  7,  6,  4,  2,  0,  0,  0}
  {11, 11, 10, 10, 10,  9,  8,  7,  6,  5,  2,  0,  0}
  {12, 12, 11, 11, 11, 10, 10,  9,  8,  7,  5,  2,  0}
  {13, 13, 12, 12, 12, 11, 11, 10,  9,  8,  7,  5,  2}
*/

//*-----------------------------------------------------------
int _ti89;
void setkey(void)
{
  key[0] = _rowread(0xfffe);
  key[1] = _rowread(0xfffd);
  key[2] = _rowread(0xfffb);
  key[3] = _rowread(0xfff7);
  key[4] = _rowread(0xffef);
  key[5] = _rowread(0xffdf);
  key[6] = _rowread(0xffbf);
}
int keyUp(void) { return key[0]&1; }
int keyLeft(void) { return key[0]&2; }
int keyDown(void) { return key[0]&4; }
int keyRight(void) { return key[0]&8; }
int key2nd(void) { return key[0]&16; }
int keyQuit(void) { return key[5]&64; }
int keyOff(void) { return key[3]&1; }
int keyNegative(void) { return key[2]&1; }
int keyZero(void) { return key[4]&1; }
int keyRepair(void) { return key[2]&64; }
int keyEnter(void) { return ((key[1]&1) || (key[1]&64)); }
int keyPlus(void) { return key[1]&2; }
int keyMinus(void) { return key[1]&4; }
int keyEsc(void) { return key[6]&1; }
int keyF1(void) { return key[5]&128; }
int keyF2(void) { return key[4]&128; }
int keyF4(void) { return key[2]&128; }
int keyF5(void) { return key[1]&128; }
//int keyDebug(void) { return key[1]&32; }
//int keyTest(void) { return key[2]&32; }
//int keyCred(void) { return key[3]&32; }
//
//           128   64     32    16  8     4    2    1
//0xfffe [0] alpha Diamnd Shift 2nd Right Down Left Up
//0xfffd [1] F5    CLEAR  ^     /   *     -    +    ENTER
//0xfffb [2] F4    BckSpc T     ,   9     6    3    (-)
//0xfff7 [3] F3    CATLG  Z     )   8     5    2    .
//0xffef [4] F2    MODE   Y     (   7     4    1    0
//0xffdf [5] F1    HOME   X     =   |     EE   STO  APPS
//0xffbf [6]                                        ESC
//
//-----------------------------------------------------------*/

//===================================================================================

/*-----------------------------------------------------------
int _ti92plus;
void setkey(void)
{
  key[0] = _rowread(0xfffe);
  key[1] = _rowread(0xfffd);
  key[2] = _rowread(0xfffb);
  key[3] = _rowread(0xfff7);
  key[4] = _rowread(0xffef);
  key[5] = _rowread(0xffdf);
  key[6] = _rowread(0xffbf);
  key[7] = _rowread(0xff7f);
  key[8] = _rowread(0xfeff);
  key[9] = _rowread(0xfdff);
}
int keyUp(void) { return key[0]&32; }
int keyLeft(void) { return key[0]&16; }
int keyDown(void) { return key[0]&128; }
int keyRight(void) { return key[0]&64; }
int keyShift(void) { return key[0]&4; }
int keyDiamond(void) { return key[0]&2; }
int keyHand(void) { return key[0]&8; }
int key2nd(void) { return ((key[0]&1) || keyShift() || keyDiamond() || keyHand()); }
int keyQuit(void) { return key[9]&8; }
int keyOff(void) { return ((key[9]&64) || (key[7]&32)); }
int keyNegative(void) { return key[9]&128; }
int keyZero(void) { return key[9]&32; }
int keyRepair(void) { return ((key[4]&1) || (key[7]&64)); }
int keyEnter(void) { return ((key[9]&2) || (key[6]&64)); }
int keyPlus(void) { return key[8]&16; }
int keyMinus(void) { return key[9]&1; }
int keyEsc(void) { return key[8]&64; }
int keyF1(void) { return key[6]&16; }
int keyF2(void) { return key[4]&16; }
int keyF4(void) {	return ((key[9]&16) || (key[5]&128)); }
int keyF5(void) {	return ((key[1]&16) || (key[6]&1)); }
//
//            128  64      32    16   8    4     2       1
//0xfffe [0]  Down Right   Up    Left Hand Shift Diamnd  2nd
//0xfffd [1]  3    2       1     F8   W    S     Z
//0xfffb [2]  6    5       4     F3   E    D     X
//0xfff7 [3]  9    8       7     F7   R    F     C       STO
//0xffef [4]  ,    )       (     F2   T    G     V       Space
//0xffdf [5]  TAN  COS     SIN   F6   Y    H     B       /
//0xffbf [6]  P    ENTER_C LN    F1   U    J     N       ^
//0xff7f [7]  *    APPS    CLEAR F5   I    K     M       =
//0xfeff [8]       ESC     MODE  +    O    L     Theta   BckSpc
//0xfdff [9]  (-)  .       0     F4   Q    A     ENTER_K -
//            Enter_C = Cursor, Enter_K = Keyboard
//-----------------------------------------------------------*/

int arrowkey(void) { return ( keyUp() || keyDown() || keyLeft() || keyRight() ); }
int keyPress(void)
{
  setkey();
  if( arrowkey() ) return 2;
  if( key[1]+key[2]+key[3]+key[4]+key[5]+key[6]+key[7]+key[8]+key[9] > -9*256 ) return 1;
  repeat = 1;
  return 0;
}
int getkey(void)
{
  int k;
  do{
    k = keyPress();
  } while( !k || !repeat );
  if( k == 1 ) repeat = 0;
  //for debugging
//  if( keyPlus() ) wind += 10;
//  else if( keyMinus() ) wind -= 10;
  if( keyOff() ) off();
  if( keyPlus() ) OSContrastUp();
  else if( keyMinus() ) OSContrastDn();
  return k;
}
void clearkey(void)
{
  int i;
  for(i = 0; i < 10; i++) key[i] = -256;
}
void stopkey(void)
{
  repeat = 0;
  clearkey();
}
int INT(float x)
{
  return (int)(x + 0.5);
}
ti_float sine(int a)
{
  return sin((float)a * PI / 180.);
}
ti_float cosine(int a)
{
  return cos((float)a * PI / 180.);
}
ti_float tangent(int a)
{
  return tan((float)a * PI / 180.);
}
int minimum(int a, int b)
{
	if( a < b ) return a;
	return b;
}
int maximum(int a, int b)
{
	if( a > b ) return a;
	return b;
}
int maxweapon(int p)
{
  return maximum(1, minimum(5, credits[p]/25));
}
int get_pixel(int x, int y)
{
  return !!(peek(0x4c00+30*y+(x>>3))&(1<<(~x&7)));
}
void drawrecth(int x, int y, int w, int h, int attr)
{
  int i, x1 = x + w - 1;
  for(i = 0; i < h; i++)
    DrawLine(x, y + i, x1, y + i, attr);
}
void drawrectv(int x, int y, int w, int h, int attr)
{
  int i, y1 = y + h - 1;
  for(i = 0; i < w; i++)
    DrawLine(x + i, y, x + i, y1, attr);
}
void drawbox(int x, int y, int w, int h, int attr)
{
  w = x + w - 1, h = y + h - 1;
  DrawLine(x, y, w, y, attr);
  DrawLine(x, h, w, h, attr);
  DrawLine(x, y+1, x, h-1, attr);
  DrawLine(w, y+1, w, h-1, attr);
}
void draw_tank(int x, int y, int a)
{
  int xx, yy, d;
  if( a > 90 ) d = -1;
  else if( a < 90 ) d = 1;
  else if( x < 80 ) d = 1;
  else d = -1;

  DrawLine(x-2, y, x+2, y, A_NORMAL);
  DrawPix(x-3, y-1, A_NORMAL);
  DrawPix(x-1, y-1, A_NORMAL);
  DrawPix(x+1, y-1, A_NORMAL);
  DrawPix(x+3, y-1, A_NORMAL);
  DrawPix(x-3, y-1, A_NORMAL);
  DrawLine(x-3*d, y-2, x+2*d, y-2, A_NORMAL);
  DrawPix(x-2*d, y-3, A_NORMAL);
  DrawLine(x-d, y-4, x, y-4, A_NORMAL);

  if( a > 90 ) a = 180-a;

  if( a <= 41 ) xx = 4;
  else if( a <= 60 ) xx = 3;
  else if( a <= 75 ) xx = 2;
  else xx = 1;

  if( a >= 49 ) yy = 4;
  else if( a >= 31 ) yy = 3;
  else if( a >= 15 ) yy = 2;
  else yy = 1;

  DrawLine(x+d, y-3, x+xx*d, y-2-yy, A_NORMAL);
}
void drawtank(int p)
{
  draw_tank(tankx[p], tanky[p], angle[p]);
}
void drawbottom(void)
{
  DrawLine(0, 99, 159, 99, A_NORMAL);
}
void drawlandpiece(int x)
{
  DrawLine(x, 99, x, land[x], A_NORMAL);
  DrawLine(x, top + 7, x, land[x]-1, A_REVERSE);
}
void drawbubble(int on_off)
{
  int i, x = tankx[turn], y = tanky[turn];
  if( on_off != -1 ) bubble = on_off;
  for(i = 0; i < 2; i++)
    if( shield[i] < 1 ) return;
  DrawClipEllipse(x, y-2, 7, 7, &(SCR_RECT){{0, 0, 159, 99}}, A_XOR);
}
void cleartank(int p)
{
  int i;
  if( bubble )
  {
    DrawLine(tankx[p]-4, tanky[p]-3, tankx[p]-4, tanky[p]-7, A_REVERSE);
    DrawLine(tankx[p]+4, tanky[p]-3, tankx[p]+4, tanky[p]-7, A_REVERSE);
  }
  else
  {
    drawlandpiece(tankx[p] - 4);
    drawlandpiece(tankx[p] + 4);
  }
  for(i = tanky[p]-7; i <= tanky[p]-1; i++)
    DrawLine(tankx[p]-3, i, tankx[p]+3, i, A_REVERSE);
  DrawLine(tankx[p]-2, tanky[p], tankx[p]+2, tanky[p], A_REVERSE);
}
void tankfall(int player)
{
  int xmin, xmax, i, dir, l, r, numplayers = 0;
  xmin = 0 - 5;
  xmax = 159 + 5;
  for(i = 0; i < 2; i++)
  {
    if( shield[i] > 0 )
    {
      numplayers++;
      if( i != player )
      {
        if( tankx[i] < tankx[player] && tankx[i] > xmin ) xmin = tankx[i];
        if( tankx[i] > tankx[player] && tankx[i] < xmax ) xmax = tankx[i];
      }
    }
  }
  xmin += 9;
  xmax -= 9;
  dir = 0;
  while( 1 )
  {
    cleartank(player);
    for(i = 0; i < 15; i++)
      drawtank(player);
    if( shield[player] < 1 ) return;
    l = tanky[player] + 1 >= land[tankx[player] - 1] || tanky[player] + 1 >= land[tankx[player] - 2] || tanky[player] >= land[tankx[player] - 3];
    r = tanky[player] + 1 >= land[tankx[player] + 1] || tanky[player] + 1 >= land[tankx[player] + 2] || tanky[player] >= land[tankx[player] + 3];
    if( l && r ) break;
    if( (r && dir == 1) || (l && dir == -1) )
    {
      cleartank(player);
      tanky[player]++;
      continue;
    }
    if( tanky[player] + 1 >= land[tankx[player]] ) break;
    if( r )
    {
    	// move left
      if( tankx[player] > xmin )
      {
        cleartank(player);
        tankx[player]--;
        dir = -1;
        continue;
      }
    }
    else if( l )
    {
    	// move right
      if( tankx[player] < xmax )
      {
        cleartank(player);
        tankx[player]++;
        dir = 1;
        continue;
      }
    }
    else
    {
      cleartank(player);
      tanky[player]++;
      continue;
    }
    break;
  }
}
void drawtanks(void)
{
  int i;
  for(i = 0; i < 2; i++)
  {
    if( shield[i] < 1 )
    {
      cleartank(i);
      // only two players
      return;
    }
  }
  for(i = 0; i < 2; i++)
    tankfall(i);
  drawbottom();
}
void drawexplosion(int x, int y, int weapon, int attr)
{
  int i, r, max = circles[weapon-1][0];
  weapon--;
  DrawLine(x - max, y, x + max, y, attr);
  for(i = 1; i <= max; i++)
  {
    r = circles[weapon][i-1];
    DrawLine(x - r, y + i, x + r, y + i, attr);
    DrawLine(x - r, y - i, x + r, y - i, attr);
  }
}
void drawshield(int x, int y, int s)
{
  int i;
  FontSetSys(F_4x6);
  printf_xy(x, y, "P%d", s+1);
  for(i = x + 9; i <= x + 49; i += 4)
  {
    DrawPix(i, y + 2, A_NORMAL);
  }
  if( shield[s] == 11 )
    DrawLine(x + 10, y + 2, x + 48, y + 2, A_REVERSE);
  for(i = y + 3; i > y; i -= 2)
  {
    DrawLine(x + 9, i, x + 49, i, A_REVERSE);
    if( shield[s] > 0 )
      DrawLine(x + 9, i, x + 9 + 4 * minimum(10, shield[s]), i, A_NORMAL);
  }
}
void scores(int draw)
{
  int i, width;
  for(i = 0; i < top + 7; i++)
    DrawLine(0, i, 159, i, A_REVERSE);
  if( !draw ) return;
  FontSetSys(F_8x10);
  for(i = 0; i < 2; i++)
  {
    if( frags[i] < -99 ) width = 32;
    else if( frags[i] < -9 || frags[i] > 99 ) width = 24;
    else if( frags[i] < 0 || frags[i] > 9 ) width = 16;
    else width = 8;
    printf_xy(minimum(maximum(0, tankx[i] - width / 2), 159 - width), top / 2 - 5, "%d", frags[i]);
  }
}
void disp(int warning)
{
  int i;
  for(i = 0; i < 2; i++)
  {
    max[i] = maximum(50, minimum(100, max[i]));
    power[i] = minimum(maximum(0, power[i]), max[i]);
    credits[i] = maximum(0, minimum(999, credits[i]));
    angle[i] = maximum(0, minimum(180, angle[i]));
  }

  // only two players
  drawshield(50, 2, 0);
  drawshield(107, 2, 1);

  FontSetSys(F_4x6);
  drawrecth(0, 26, 160, 5, A_REVERSE);
  // only two players
  if( warning && shield[turn] > 0 && shield[turn] <= maxweapon(1-turn) && !( players == 1 && turn == AI ) )
    printf_xy(61, 26, "Low shield");
  printf_xy(2, 2, "Angle");
  printf_xy(2, 10, "Power");
  printf_xy(2, 18, "Prev.");
  printf_xy(70, 10, "Max.");
  if( wind == 0 )
  {
    FontSetSys(F_6x8);
    printf_xy(70, 17, "    ");
    FontSetSys(F_4x6);
    printf_xy(50, 18, "No Wind");
  }
  else printf_xy(50, 18, "Wind  ");
  printf_xy(107, 18, "Credits");
  printf_xy(107, 10, "Explosive");

  FontSetSys(F_6x8);
  printf_xy(26, 1, "  ");
  if( angle[turn] > 90 ) printf_xy(26, 1, "%d", 180-angle[turn]);
  else printf_xy(26, 1, "%d", angle[turn]);

  if( power[turn] < 10 ) i = 38;
  else if( power[turn] < 100 ) i = 41;
  else i = 44;
  printf_xy(26, 9, "       ");
  printf_xy(26, 9, "%d", power[turn]);
  printf_xy(i, 9, "/");
  printf_xy(50, 9, "%d", max[turn]);

  printf_xy(26, 17, "   ");
  if( prev[turn] != -1 ) printf_xy(26, 17, "%d", prev[turn]);
  
  if( wind != 0 ) printf_xy(70, 17, "    ");
  if( wind < 0 ) printf_xy(70, 17, "<-%d", -wind);
  else if( wind > 0 ) printf_xy(70, 17, "%d->", wind);

  printf_xy(139, 17, "%d  ", credits[turn]);

  FontSetSys(F_8x10);
  printf_xy(144, 7, "%d", weapon);
}
void info(void)
{
  int w = weapon;
  turn = 1-turn, weapon = 1;
  disp(0);
  FontSetSys(F_4x6);
  printf_xy(54, 26, "Player %d status", turn + 1);
  while( keyPress() );
  turn = 1-turn, weapon = w;
  disp(1);
}
void drawland(void)
{
  int i, j, slope = 0, length, x, b = (random(41) + top + 19) * 2;
  ClrScr();
  round++;
  weapon = 1;
  wind = (windmode == 1 ? 0 : random(199) - 99);
  // only two players
  tankx[0] = 14 + random(25);
  tankx[1] = 145 - random(25);
  for(i = 0; i < 2; i++)
  {
    if( tankx[i] < 80 )
      angle[i] = 35;
    else
      angle[i] = 145;
    tanky[i] = top + 19;
    power[i] = 45;
    max[i] = 100;
    prev[i] = -1;
    shield[i] = 11;
    credits[i] = (gamemode == 1 ? 350 : 0);
  }
  for(x = 0, i = 1, length = 0; x < 160; x++, i++)
  {
    for(j = 0; j < 2; j++)
    {
      if( x == tankx[j] - 3 )
      {
        i = 1;
        slope = 0;
        length = 9;
        tanky[j] = b/2 - 1;
      }
    }
    if( i >= length )
    {
      i = 1;
      slope = random(7) - 3;
      if( slope == 3 ) slope = 4;
      if( slope == -3 ) slope = -4;
      length = random(5) + 4;
    }
    if( slope < 0 && b <= (top + 19) * 2 )
    {
      i = 1;
      slope = random(4);
      if( slope == 3 ) slope = 4;
      length = random(5) + 4;
    }
    if( slope > 0 && b >= (top + 19 + 40) * 2 )
    {
      i = 1;
      slope = -random(4);
      if( slope == -3 ) slope = -4;
      length = random(5) + 4;
    }
    b += slope;
    DrawLine(x, 99, x, b/2, A_NORMAL);
    land[x] = b/2;
  }
  disp(1);
  drawtanks();
  drawbubble(1);
  stopkey();
}
void restoreland(void)
{
  int x;
  ClrScr();
  for(x = 0; x < 160; x++)
    DrawLine(x, 99, x, land[x], A_NORMAL);
  drawtanks();
  drawbubble(1);
  disp(1);
}
void redrawland(int left, int right)
{
  int x;
  left = maximum(0, left), right = minimum(159, right);
  for(x = left; x <= right; x++)
    drawlandpiece(x);
  drawtanks();
}
void drawhit(int x, int y)
{
  int a;
  for(a = 0; a < 50; a++)
  {
    DrawLine(x-7, y+5, x+7, y-9, A_XOR);
    DrawLine(x-7, y-9, x+7, y+5, A_XOR);
    DrawLine(x-7, y+4, x+6, y-9, A_XOR);
    DrawLine(x-6, y-9, x+7, y+4, A_XOR);
    DrawLine(x-6, y+5, x+7, y-8, A_XOR);
    DrawLine(x-7, y-8, x+6, y+5, A_XOR);
//    xx = x-3+random(7), yy = y-1-random(5);
//    drawbox(xx-1, yy-1, 3, 3, get_pixel(xx, yy));
  }
}
void repair(void)
{
  if( credits[turn] >= 30 && shield[turn] < 10 ) shield[turn]++, max[turn] = minimum(100, max[turn] + 10), credits[turn] -= 30;
  weapon = minimum(maximum(1, weapon), maxweapon(turn));
}
int xstart(void)
{
  float d;
  if( angle[turn] > 90 ) d = -1.;
  else if( angle[turn] < 90 ) d = 1.;
  else if( tankx[turn] < 80 ) d = 1.;
  else d = -1.;
  return INT((float)tankx[turn] + cosine(angle[turn]) * 5.1 + d);
}
int ystart(void)
{
  return INT((float)tanky[turn] - sine(angle[turn]) * 5.1 - 3.);
}
void drawBullet(int x, int y, int attr)
{
  if( y < 0 )
  {
    return;

    if( x < 0 )
      DrawPix(0, 0, attr);
    else if( x > 159 )
      DrawPix(159, 0, attr);
    else
      DrawLine(x-1, 0, x+1, 0, attr);
  }
  else if( x < 0 )
  {
//    DrawLine(0, y+1, 0, y-1, attr);
  }
  else if( x > 159 )
  {
//    DrawLine(159, y+1, 159, y-1, attr);
  }
  else {
    y = maximum(0, y);
    if( y < top ) attr = A_XOR;
    DrawLine(x-1, y, x+1, y, attr);
    if( y > top+1 || (y < top-1 && y > 1) )
    {
      DrawPix(x, y-1, attr);
      DrawPix(x, y+1, attr);
    }
  }
}
int istank(int i)
{
  return x0 > tankx[i]-4 && x0 < tankx[i]+4 && y0 > tanky[i]-6 && y0 <= tanky[i];
}
int tankhitpiece(int x, int y, int i)
{
  if( x < -circles[i][0] || x > circles[i][0] ) return 0;
  if( x < 0 ) return -circles[i][-x-1] <= y && y <= circles[i][-x-1];
  if( x > 0 ) return -circles[i][x-1] <= y && y <= circles[i][x-1];
  return -circles[i][0] <= y && y <= circles[i][0];
}
int tankhit(int p)
{
  int x = x0, y = y0, xt = tankx[p] - x, yt = tanky[p] - y, a = angle[p], i = weapon - 1, xx, yy, d;
  if( tankhitpiece(xt-3, yt-2, i) ) return 1;
  if( tankhitpiece(xt+3, yt-2, i) ) return 1;
  if( tankhitpiece(xt-3, yt, i) ) return 1;
  if( tankhitpiece(xt+3, yt, i) ) return 1;
  if( tankhitpiece(xt-3, yt-4, i) ) return 1;
  if( tankhitpiece(xt+3, yt-4, i) ) return 1;
  if( tankhitpiece(xt, yt, i) ) return 1;

  if( a > 90 ) d = -1;
  else if( a < 90 ) d = 1;
  else if( xt < 80 ) d = 1;
  else d = -1;

  if( a > 90 ) a = 180-a;

  if( a <= 41 ) xx = 4;
  else if( a <= 60 ) xx = 3;
  else if( a <= 75 ) xx = 2;
  else xx = 1;

  if( a >= 49 ) yy = 4;
  else if( a >= 31 ) yy = 3;
  else if( a >= 15 ) yy = 2;
  else yy = 1;

  return tankhitpiece(xt + d * xx, yt - 2 - yy, i);
}
void blastdirt(int xland, int size)
{
  int yland, top = y0 - size, bottom = y0 + size;
  if( xland >= 0 && xland <= 159 )
  {
    yland = land[xland];
    if( yland <= top )
    {
      if( bottom >= 99)
        yland = 99 - (top - yland);
      else
        yland += 1 + 2 * size;
    }
    else if( yland <= bottom )
      yland = bottom + 1;
    land[xland] = minimum(yland, 99);
  }
}
void boom(void)
{
  int i, j, hit = -1, r = circles[weapon-1][0], newcredits = 0;
  if( turn == AI ) ai_dx = x0 - tankx[AI], ai_dy = y0 - tanky[AI];
  for(i = 0; i < 2; i++)
    if( istank(i) || tankhit(i) )
      hit = i;
  if( x0+r >= 0 && x0-r <= 159)
  {
    for(j = 0; j < 9; j++)
    {
      for(i = 0; i < 100 / (r + 1); i++)
        drawexplosion(x0, y0, weapon, A_REVERSE);
      for(i = 0; i < 100 / (r + 1); i++)
        drawexplosion(x0, y0, weapon, A_NORMAL);
    }
    drawexplosion(x0, y0, weapon, A_REVERSE);

//    for(i = 0; i < 1000 / (circles[weapon-1][0] + 1) + 4 * weapon; i++)
//      drawexplosion(x0, y0, weapon, A_XOR);
//    drawexplosion(x0, y0, weapon, A_REVERSE);

    if( hit != -1 )
    {
      if( shield[hit] == 11 ) max[hit] += 5;
      max[hit] = maximum(50, max[hit] - 5 * weapon);
      if( gamemode == 2 )
        shield[hit] = 0;
      else
        shield[hit] -= weapon;
      if( hit == turn )
      {
        if( shield[hit] < 1 ) frags[turn]--;
      }
      else
      {
        newcredits += ((credits[turn] < 150 ? 3 : 1) + 2) * weapon;
        if( shield[hit] < 1 ) frags[turn]++;
      }
      drawtank(hit);
      disp(0);
      drawhit(tankx[hit], tanky[hit]);
    }
    // begin dirt update
    drawbottom();
    blastdirt(x0, r);
    for(i = 0; i < r; i++)
    {
      blastdirt(x0 - 1 - i, circles[weapon-1][i]);
      blastdirt(x0 + 1 + i, circles[weapon-1][i]);
    }
    redrawland(x0-r, x0+r);
    // end dirt update
  }
  if( shield[turn] > 0 )
  {
    if( credits[turn] >= 150 ) newcredits -= 6;
    if( shield[turn] > shield[3-turn] ) newcredits += 8;
    else if( shield[turn] == shield[3-turn] ) newcredits += 10;
    else if( shield[turn] < shield[3-turn] ) newcredits += 13;
  }
  // only two players
  // high
  if( shield[1-turn] <= shield[turn] ) newcredits += 6 + 2;
  // low
  else if( shield[1-turn] > shield[turn] ) newcredits += 11 + 2;
  // other
  //else newcredits += 8 + 2;
  if( credits[turn] >= 150 ) newcredits -= 6;
  credits[turn] = minimum(999, credits[turn] + newcredits);
  weapon = 1, turn = 1 - turn;
  if( windmode == 3 ) wind = maximum(-99, minimum(99, wind + random(41) - 20));
  if( windmode == 4 ) wind = random(199) - 99;
  disp(1);
  stopkey();
  drawtanks();
}
void fire(void)
{
  int hit = -2, i, l = 8, mx[l], my[l], xs, ys;
  float t = ZERO, w, c, s;
  ai_power = power[AI];
  weapon = maximum(1, minimum(weapon, maxweapon(turn)));
  if( weapon > 1 )
    credits[turn] -= 25 * weapon;
  drawbubble(0);
  disp(0);
  drawtanks();
  prev[turn] = power[turn];
  c = cosine(angle[turn]) * (float)power[turn] / 4.4;
  s = - sine(angle[turn]) * (float)power[turn] / 4.4;
  w = (float)wind / 384.;
  xs = xstart(), ys = ystart();
  for(i = 0; i < l; i++) mx[i] = xs, my[i] = ys;
  do
  {
    drawBullet(mx[0], my[0], A_NORMAL);
    if( t >= 0.24 ) drawBullet(mx[l-1], my[l-1], A_REVERSE);
    for(i = l - 1; i > 0; i--)
    {
      mx[i] = mx[i-1];
      my[i] = my[i-1];
    }
    x0 = INT((float)xs + (c + w * t) * t);
    y0 = INT((float)ys + (s + 1.22875 * t) * t);
    mx[0] = x0, my[0] = y0;
    for(i = 0; i < 2; i++)
      if( istank(i) )
        hit = i;
    i = minimum(maximum(x0, 0), 159);
    if( y0+1 >= land[i] || y0 >= land[maximum(i-1, 0)] || y0 >= land[minimum(i+1, 159)] ) hit = -1;
    t += 0.0935;
  }
  while( x0 < 400 && y0 < 99 && x0 > -240 && hit == -2 );
  for(i = l - 1; i > 0; i--) drawBullet(mx[i], my[i], A_REVERSE);
  boom();
  drawbubble(1);
}
int maxheight(int a, int p)
{
  return - INT(pow((float)p / 4.4 * sine(a), 2.) / 4.915);
}
void debug(int i)
{
  FontSetSys(F_8x10);
    printf_xy(76, 32, "%d   ", i);
}
void findangle(int min, int max, int step)
{
  float t, p = (float)power[AI] / 4.4, w = ((float)wind / 384.), pos = 998, prev_pos = 999;
  angle[AI] = min;
  while( angle[AI] <= max )
  {
    // if this angle won't reach vertically
    if( maxheight(angle[AI], power[AI]) > tanky[HUMAN] - ystart() )
    {
      if( step == 1 && angle[AI] > min )
        angle[AI]--;
//      debug(1);
      break;
    }

    // this angle reaches vertically.  check horizontal reach
    prev_pos = pos;
    pos = p * sine(angle[AI]);
    // t = time when projectile will land at height of opponent
    t = (pos + sqrt(pow(pos, 2.) + 9.83 / 4. * 2. * (float)(tanky[HUMAN] - ystart()))) / (9.83 / 4.);
    pos = (p * cosine(angle[AI]) + w * t) * t;

    // if this angle reaches both vertically and horizontally
    if( pos <= (float)(tankx[HUMAN] - xstart()) )
    {
//      debug((int)pos - (tankx[HUMAN] - xstart()));
      break;
    }

    // if the previous angle reached farther
    if( pos >= prev_pos )
    {
      // if step is 1, then previous angle is the best
      if( step == 1 )
        angle[AI]--;
//      debug(3);
      break;
    }

    if( angle[AI] < max ) angle[AI] += step;
  }

//  if( angle[AI] == max )
//    debug((int)pos - (tankx[HUMAN] - xstart()));

  if( step > 1 )
    findangle(angle[AI] - step, angle[AI], 1/*step / 2*/);
//  else if( pos > (float)(tankx[HUMAN] - xstart()) )
//    weapon = 1;
}
void think(void)
{
  int x, i;
  float t, s, c, w = ((float)wind / 384.);
  FontSetSys(F_4x6);
  printf_xy(63, 26, "Thinking...");

  power[AI] = max[AI], i = credits[AI], weapon = 1, angle[AI] = 90;
  while( power[AI] < 100 && i >= 30 )
    i -= 30, power[AI] = minimum(100, power[AI] + 10);
  if( skill == 3 ) weapon = maxweapon(AI);
  if( skill == 2 && random(3) > 0 ) weapon = minimum(maxweapon(AI), 2 + random(4));

  findangle(90, 180, 3);

  if( angle[AI] < 90 )
    angle[AI] = 90;

  x = tankx[HUMAN] - 3 - xstart();
  c = cosine(angle[AI]);
  s = sine(angle[AI]);
  t = sqrt(((float)x * s + (float)(tanky[HUMAN] - ystart()) * c) / (w * s + 1.22875 * c));
  power[AI] = INT(((float)x / t - w * t) * 4.4 / c);

  if( skill == 2 ) power[AI] = power[AI] + 2 - random(7);
  if( power[AI] < 1 ) power[AI] = max[AI], weapon = 1;
  ai_want = power[AI];
}
void getkeyrepeat(int delay)
{
  int i, k = keyPress();
  if( k == 2 ) repeat = maximum(repeat, 1);
  else if( k == 1 ) repeat = 0;
  if( k == 0 ) getkey();
  else if( k == 2 && repeat )
  {
    for(i = 0; i <= delay / repeat; i++)
    {
      k = keyPress();
      if( k < 2 )
      {
        repeat = 1 - k;
        return;
      }
    }
    repeat = 4;
  }
  else getkey();
}
void drawtitle(int draw)
{
  if( !draw )
  {
    drawrecth(50, 4, 60, 23, A_REVERSE);
    return;
  }
  drawbox(50, 4, 60, 23, A_NORMAL);
  drawbox(51, 5, 58, 21, A_NORMAL);
  FontSetSys(F_8x10);
  printf_xy(60, 11, "Tanks");
}
int help()
{
  int x = 3, y = 13, i, j, k;
  // clear
  ClrScr();
  FontSetSys(F_4x6);
  printf_xy(48, 4, "Controls for Tanks");
  i = 0, j = x + 108;
  printf_xy(x, y+7*i, "Change angle:"); printf_xy(j - 39, y+7*i, "LEFT, RIGHT"); i++;
  printf_xy(x, y+7*i, "Change power:"); printf_xy(j - 31, y+7*i, "UP, DOWN"); i++;
  printf_xy(x, y+7*i, "Change by 5:"); printf_xy(j - 46, y+7*i, "2ND + ARROWS"); i++;
  printf_xy(x, y+7*i, "Change explosive:"); printf_xy(j - 20, y+7*i, "F4, F5"); i++;
  printf_xy(x, y+7*i, "Repair:"); printf_xy(j - 36, y+7*i, "BACKSPACE"); i++;
  printf_xy(x, y+7*i, "Fire:"); printf_xy(j - 45, y+7*i, "CLEAR, ENTER"); i++;
  printf_xy(x, y+7*i, "View opponent's status:"); printf_xy(j - 7, y+7*i, "F1"); i++;
  printf_xy(x, y+7*i, "View current score:"); printf_xy(j - 7, y+7*i, "F2"); i++;
  printf_xy(x, y+7*i, "Exit to menu:"); printf_xy(j - 11, y+7*i, "ESC"); i++;
  printf_xy(x, y+7*i, "Exit to home screen:"); printf_xy(j - 17, y+7*i, "HOME"); i++;
  printf_xy(x, y+7*i, "Change contrast:"); printf_xy(j - 41, y+7*i, "PLUS, MINUS"); i++;
  printf_xy(x, y+7*i, "Turn off calc:"); printf_xy(j - 48, y+7*i, "DECIMAL POINT"); i++;
  x = j + 6, y--;
  // top
  DrawLine(x+1, y+0, x+37, y+0, A_NORMAL);
  // sides
  DrawLine(x+0, y+1, x+0, y+79, A_NORMAL);
  DrawLine(x+38, y+1, x+38, y+79, A_NORMAL);
  // screen
  drawbox(x+3, y+5, 33, 21, A_NORMAL);
  drawrecth(x+4, y+20, 31, 5, A_NORMAL);
  draw_tank(x+10, y+19, 35);
  draw_tank(x+28, y+19, 145);
  // bottom
  DrawPix(x+1, y+80, A_NORMAL);
  DrawPix(x+37, y+80, A_NORMAL);
  DrawLine(x+2, y+81, x+4, y+81, A_NORMAL);
  DrawLine(x+34, y+81, x+36, y+81, A_NORMAL);
  DrawLine(x+5, y+82, x+11, y+82, A_NORMAL);
  DrawLine(x+27, y+82, x+33, y+82, A_NORMAL);
  DrawLine(x+12, y+83, x+26, y+83, A_NORMAL);
  // buttons
  for(i = 0; i < 5; i++)
  {
    // fkeys
    drawrecth(x+3+7*i, y+28, 5, 3, A_NORMAL);
    for(j = 0; j < 9; j++)
    {
      if(
        (j == 0 && i % 2 == 0) ||
        (j == 2 && (i == 0 || i > 2)) ||
        (i == 2 && j == 8) ||
        (i == 4 && j > 5)
      )
        drawrecth(x+3+7*i, y+35+5*j, 5, 3, A_NORMAL);
      else
        drawbox(x+3+7*i, y+35+5*j, 5, 3, A_NORMAL);
      if( i > 0 && i < 4 && j > 4 )
      {
        DrawPix(x+3+7*i, y+35+5*j+2, A_REVERSE);
        DrawPix(x+3+7*i+4, y+35+5*j+2, A_REVERSE);
      }
    }
  }
  // f3
  DrawLine(x+18, y+29, x+20, y+29, A_REVERSE); // f3
  // arrow keys
  drawrecth(x+24, y+35, 12, 8, A_REVERSE);
  // up
  drawrecth(x+27, y+33, 6, 3, A_NORMAL);
  // down
  drawrecth(x+27, y+40, 6, 3, A_NORMAL);
  // left
  drawrecth(x+24, y+35, 3, 6, A_NORMAL);
  // right
  drawrecth(x+33, y+35, 3, 6, A_NORMAL);
  // corners
  DrawLine(x+26, y+35, x+27, y+35, A_REVERSE);
  DrawLine(x+26, y+40, x+27, y+40, A_REVERSE);
  DrawLine(x+32, y+35, x+33, y+35, A_REVERSE);
  DrawLine(x+32, y+40, x+33, y+40, A_REVERSE);
  // done drawing the calculator

  stopkey();
  i = 1, y += 19, j = 35, k = 145;
  do
  {
    getkeyrepeat(1000);
    if( keyQuit() ) i = -1;
    else if( keyEsc() ) i = 0;
    else if( keyLeft() != keyRight() )
    {
      if( key2nd() ) k += (keyLeft() ? 5 : -5);
      else j += (keyLeft() ? 5 : -5);
      if( j < 0 ) j = 180;
      if( k < 0 ) k = 180;
      if( j > 180 ) j = 0;
      if( k > 180 ) k = 0;
    	drawrecth(x + (key2nd() ? 28 : 10) - 4, y - 6, 9, 7, A_REVERSE);
      draw_tank(x + (key2nd() ? 28 : 10), y, (key2nd() ? k : j));
    }
  } while( !keyEnter() && i == 1 );
  return i;
}
int menu(char *items[], int numitems, int value, int *disabled)
{
  int x, y, w, h, i;
  for(w = 0, i = 0; i < numitems; i++)
    w = maximum(w, strlen(items[i]));
  w = 18 + 6 * w;
  h = 5 + 9 * numitems;
  x = 80 - w / 2;
  y = 31;
  drawbox(x, y, w, h, A_NORMAL);
  FontSetSys(F_6x8);
  for(i = 0; i < numitems; i++)
    DrawStr(x + 14, y + 3 + 9 * i, items[i], (disabled[i] ? A_SHADED : A_REPLACE));
  draw_tank(x + 7, y - 1 + value * 9, 0);

  stopkey();
  while( 1 )
  {
    getkeyrepeat(2000);
    if( arrowkey() )
    {
      i = value;
      if( (keyUp() || keyLeft()) && !(keyDown() || keyRight()) )
      {
        do
        {
          value--;
          if( value < 1 )
            value = numitems;
        } while( i != value && disabled[value - 1] );
      }
      else if( (keyDown() || keyRight()) && !(keyUp() || keyLeft()) )
      {
        do
        {
          value++;
          if( value > numitems )
            value = 1;
        } while( i != value && disabled[value-1] );
      }
      if( i != value )
      {
        drawrectv(x + 4, y + 1, 8, h - 2, A_REVERSE);
        draw_tank(x + 7, y - 1 + value * 9, 0);
      }
    }
    else if( keyEsc() )
    {
      value = 0;
      break;
    }
    else if( keyQuit() )
    {
      value = -1;
      break;
    }
    else if( keyEnter() && !disabled[value - 1] ) break;
  }
  drawrecth(x, y, w, h, A_REVERSE);
  return value;
}
void options(char *items[], int numvalues[], int index[], int values[], int disabled[])
{
  int x, y, w, h, i, valueH, valueW, valueX;
  valueX = 49, valueW = 1 + 6 * strlen(items[index[values[0] - 1] + values[values[0]]]), valueH = 10;
  w = 160;
  h = 14 + valueH * numvalues[0];
  x = 80 - w / 2;
  y = 31;
  drawrecth(x, y, w, h, A_REVERSE);
  drawbox(x, y, w, h, A_NORMAL);
  FontSetSys(F_4x6);
  printf_xy(x + 2, y + 3, items[0]);
  y += 10, h -= 10;
  DrawLine(x + 1, y, x + w - 2, y, A_NORMAL);
  for(i = 0; i < numvalues[0]; i++)
    DrawStr(x + 2, y + 4 + valueH * i, items[index[i]], (disabled[i] ? A_SHADED : A_REPLACE));
  FontSetSys(F_6x8);
  for(i = 0; i < numvalues[0]; i++)
    DrawStr(x + valueX, y + 3 + valueH * i, items[index[i] + values[i + 1]], (disabled[i] ? A_SHADED : A_REPLACE));
  if( values[values[0]] > 1 )
    DrawStr(x + valueX - 6, y + 3 + valueH * (values[0] - 1), "\031", A_REPLACE);
  if( values[values[0]] < numvalues[values[0]] )
    DrawStr(x + valueX + valueW, y + 3 + valueH * (values[0] - 1), "\032", A_REPLACE);
  drawrecth(x + valueX, y + 2 + valueH * (values[0] - 1), valueW, valueH, A_XOR);

  stopkey();
  while( 1 )
  {
    getkeyrepeat(1750);
    if( keyUp() || keyDown() )
    {
      i = values[0];
      if( keyUp() && !keyDown() )
      {
        do
        {
          values[0]--;
          if( values[0] < 1 )
            values[0] = numvalues[0];
        } while( i != values[0] && disabled[values[0]-1] );
      }
      else if( keyDown() && !keyUp() )
      {
        do
        {
          values[0]++;
          if( values[0] > numvalues[0] )
            values[0] = 1;
        } while( i != values[0] && disabled[values[0]-1] );
      }
      if( i != values[0] )
      {
        drawrecth(x + valueX, y + 2 + valueH * (i - 1), valueW, valueH, A_XOR);
        DrawStr(x + valueX - 6, y + 3 + valueH * (i - 1), " ", A_REPLACE);
        DrawStr(x + valueX + valueW, y + 3 + valueH * (i - 1), " ", A_REPLACE);
        valueW = 1 + 6 * strlen(items[index[values[0] - 1] + values[values[0]]]);
        if( values[values[0]] > 1 )
          DrawStr(x + valueX - 6, y + 3 + valueH * (values[0] - 1), "\031", A_REPLACE);
        if( values[values[0]] < numvalues[values[0]] )
          DrawStr(x + valueX + valueW, y + 3 + valueH * (values[0] - 1), "\032", A_REPLACE);
        drawrecth(x + valueX, y + 2 + valueH * (values[0] - 1), valueW, valueH, A_XOR);
      }
    }
    else if( keyLeft() || keyRight() )
    {
      i = values[values[0]];
      if( keyLeft() && !keyRight() && values[values[0]] > 1 ) values[values[0]]--;
      else if( keyRight() && !keyLeft() && values[values[0]] < numvalues[values[0]] ) values[values[0]]++;
      if( i != values[values[0]] )
      {
        drawrecth(x + valueX, y + 2 + valueH * (values[0] - 1), valueW + 6, valueH, A_REVERSE);
        valueW = 1 + 6 * strlen(items[index[values[0] - 1] + values[values[0]]]);
        DrawStr(x + valueX - 6, y + 3 + valueH * (values[0] - 1), (values[values[0]] > 1 ? "\031" : " "), A_REPLACE);
        if( values[values[0]] < numvalues[values[0]] )
          DrawStr(x + valueX + valueW, y + 3 + valueH * (values[0] - 1), "\32", A_REPLACE);
        drawrecth(x + valueX, y + 2 + valueH * (values[0] - 1), valueW, valueH, A_NORMAL);
        DrawStr(x + valueX, y + 3 + valueH * (values[0] - 1), items[index[values[0] - 1] + values[values[0]]], A_REVERSE);
      }
    }
    else if( keyEsc() )
    {
      values[0] = 0;
      break;
    }
    else if( keyQuit() )
    {
      values[0] = -1;
      break;
    }
    else if( keyEnter() && !disabled[values[0] - 1] ) break;
  }
  drawrecth(x, y - 10, w, h + 10, A_REVERSE);
}
int title(void)
{
  int menu_value = (turn == -1 ? 1 : 3);
  int menu_disabled[] = {0, 0, (turn == -1), 0};
  int values[] = {0, skill, gamemode, windmode, type, limit};
  int options_disabled[] = {0, 0, 0, 0, 0};

  stopkey();

  draw:
  ClrScr();
  drawtitle(1);

  main:
  FontSetSys(F_4x6);
  printf_xy(46, 76, "Version:  2003.08.17");
  printf_xy(37, 84, "2000-2003 Andy Dufilie");
  printf_xy(33, 92, "http://come.to/andys.site/");

  menu_value = menu(
    (char*[]){
      "One player game",
      "Two player game",
      "Resume current game",
      "View game controls"
    }, // items
    4, // numitems
    menu_value, // default
    menu_disabled // disabled
  );
  if( menu_value < 1 ) return 0;
  if( menu_value == 3 )
  {
    restoreland();
    return 1;
  }
  if( menu_value == 4 )
  {
    if( help() == -1 ) return 0;
    goto draw;
  }

  drawrecth(0, 75, 160, 25, A_REVERSE);
  values[0] = (menu_value == 1 ? 1 : 2);
  options_disabled[0] = (menu_value != 1);
  options(
    (char*[]){
      "Game settings",
      "Opponent:", "Fuzzy Logic", "Cheater", "Cheater No. 2",
      "Game mode:", "Normal", "Instagib",
      "Wind mode:", "No wind", "Constant wind", "Changing: Gradual", "Changing: Instant",
      "Limit type:", "Frag limit", "Round limit",
      "Limit:", "1", "2", "3", "4", "5", "6", "7", "8", "9", "10", "11", "12", "13", "14", "15", "No limit"
    },
    (int[]){5, 3, 2, 4, 2, 16}, // numvalues
    (int[]){1, 5, 8, 13, 16}, // beginning indexes
    values, // defaults
    options_disabled // disabled
  );

  if( values[0] == -1 ) return 0;
  if( values[0] == 0 ) goto main;

  // starting a new game
  players = menu_value, skill = values[1], gamemode = values[2], windmode = values[3], type = values[4], limit = values[5];
  round = 0, turn = random(2);
  for(menu_value = 0; menu_value < 2; menu_value++)
    frags[menu_value] = 0, shield[menu_value] = 0;
  return 1;
}
void scramble(void)
{
  int x, y;
  stopkey();
  do{
    x = random(160), y = random(100);
    drawrecth(x - 1, y - 1, 3, 3, get_pixel(x, y));
  } while( !keyPress() || repeat == 0 );
  restoreland();
  stopkey();
}
void scramble2(void)
{
  int x, y;
//  ClrScr(); for(x=0;x<=159;x+=8) for(y=x;y<x+4;y++) DrawLine(y, 0, y, 99, A_NORMAL);
  stopkey();
  do{
    x = 4 * random(40), y = 4 * random(25);
    drawrecth(x - 4, y - 4, 12, 12, get_pixel(x, y));
  } while( !keyPress() || repeat == 0 );
  restoreland();
  stopkey();
}
//char _comment[] = "Tanks by Andy Dufilie - http://come.to/andys.site/";
int _main(void)
{
  int i, j, ready = 0, dx, dy;
//  int debugmode = 0;

  OSSetSR(0x0400);
  OSEnableBreak();

  randomize();

  title:
  if( !title() ) goto exit;
  stopkey();

  key:

  // count active players
  for(i = 0, j = 0; i < 2; i++)
    if( shield[i] > 0 ) j++;
  if( j < 2 )
  {
    drawland();
    ready = 0;
  }

  if( key2nd() ) i = 5;
  else i = 1;

/*
  if( keyDebug() ) debugmode = !debugmode;
  if( debugmode )
  {
    drawexplosion(x0, y0, weapon, A_REVERSE);
    drawtanks();
    if( keyUp() )
      y0 -= i;
    else if( keyDown() )
      y0 += i;
    if( keyRight() )
      x0 += i;
    else if( keyLeft() )
      x0 -= i;
    drawexplosion(x0, y0, weapon, A_NORMAL);
    debug(tankhit(0) || tankhit(1));
  }
  else
*/
  if( arrowkey() )
  {
    if( keyUp() )
    {
      power[turn] = minimum(power[turn] + i, max[turn]);
      disp(1);
    }
    else if( keyDown() )
    {
      power[turn] = maximum(0, power[turn] - i);
      disp(1);
    }
    if( keyRight() )
    {
      if( angle[turn] == 0 )
        angle[turn] = 180;
      else
        angle[turn] = maximum(0, angle[turn] - i);
      disp(1);
      cleartank(turn);
      drawtank(turn);
    }
    else if( keyLeft() )
    {
      if( angle[turn] == 180 )
        angle[turn] = 0;
      else
        angle[turn] = minimum(180, angle[turn] + i);
      disp(1);
      cleartank(turn);
      drawtank(turn);
    }
  }
  else
  {
//    if( keyTest() ) max[AI] = 50, credits[AI] = 0, shield[AI] = 1;
//    if( keyCred() ) credits[AI] += 30;

    if( keyF1() ) info();
    else if( keyF2() )
    {
      scores(1);
      FontSetSys(F_4x6);
      printf_xy(56, 26, "Current score");
      while( keyPress() );
      scores(0);
      disp(1);
    }
    if( keyQuit() ) goto exit;
    else if( keyEsc() ) goto title;
    if( keyF5() )
    {
      weapon++;
      weapon = maximum(1, minimum(weapon, maxweapon(turn)));
      disp(1);
    }
    else if( keyF4() )
    {
      weapon--;
      weapon = maximum(1, minimum(weapon, maxweapon(turn)));
      disp(1);
    }

    if( keyRepair() )
    {
      repair();
      disp(1);
    }
    else if( keyEnter() || (players == 1 && turn == AI && ready == 1)  )
    {
      fire();
      ready = 0;
    }
    if( i == 5 && keyNegative() ) scramble();
    else if( i == 5 && keyZero() ) scramble2();
  }

  if( credits[turn] < 30 ) weapon = 1;

  // count active players
  for(i = 0, j = 0; i < 2; i++)
    if( shield[i] > 0 )
      j++;
  if( j < 2 )
  {
  	for(i = 0; i < 2; i++)
    {
      if( limit < 16 && (type == 1 ? frags[i] : round) >= limit )
      {
        for(i = 0; i < 2; i++)
          drawtank(i);
        scores(1);
        FontSetSys(F_4x6);
        printf_xy(60, 26, "Final score");
        drawrecth(76-3*9, 42, 8+6*9, 16, A_REVERSE);
        drawbox(76-3*9, 42, 8+6*9, 16, A_NORMAL);
        FontSetSys(F_6x8);
        printf_xy(80-3*9, 46, "Game over");
        do
        {
          stopkey();
          getkey();
        } while( !keyEsc() && !keyEnter() && !keyQuit() );
        turn = -1;
        if( keyQuit() ) goto exit;
        goto title;
      }
    }
    goto key;
  }

  if( players == 1 && turn == AI )
  {
    if( skill == 1 )
    {
      weapon = 1, dx = tankx[HUMAN] - tankx[AI], dy = tanky[HUMAN] - tanky[AI];
      angle[AI] = 180 - 65 + INT((float)wind / 99. * (wind > 0 ? 10. : 15.));
      if( prev[AI] == -1 )
      {
        ai_want = (wind > 0 ? 70 + INT((float)wind / 99. * 10.8) : 70);
        ai_dx = -80, ai_dy = 0, ai_power = ai_want;
      }
      if( ai_dx > dx-15 && ai_dx < dx+15 && ai_dy < dy+10 && ai_dy > dy-12 )
      {
        if( prev[AI] != -1 )
          weapon = maxweapon(AI);
        if( !ready )
        {
          if( ai_dy > dy ) ai_want = ai_power + (ai_dx < dx ? -2 : 1);
          if( ai_dx < dx-4 || (ai_dy < dy-4 && ai_dx <= dx) ) ai_want = ai_power - 3;
          if( ai_dx > dx+4 || (ai_dy > dy && ai_dx >= dx) ) ai_want = ai_power + 2;
        }
      }
      else if( !ready )
      {
        if( ai_dy > dy ) ai_want = ai_power + (ai_dx < dx ? -6 : 5);
        if( ai_dx < dx-15 ) ai_want = ai_power - 8;
        if( ai_dx > dx+15 ) ai_want = ai_power + 7;
        if( ai_dx < dx-35 || (ai_dx < dx && ai_dy < dy-30) ) ai_want = ai_power - 14;
        if( ai_dx > dx+35 || (ai_dx > dx && ai_dy > dy+30) ) ai_want = ai_power + 13;
//        if( ai_dx < dx-35 && wind >= 75 ) ai_want = ai_power - 10;
//        if( ai_dx > dx+35 && wind <= -75 ) ai_want = ai_power + 9;
      }
    }
    else think();
    ai_want = maximum(0, minimum(100, ai_want));
    while( credits[AI] >= 30 && shield[AI] < 10 && (shield[AI] <= maxweapon(HUMAN) || ai_want > max[AI]) )
    {
      repair();
      disp(0);
    }
    power[AI] = ai_want;
    cleartank(AI);
    drawtank(AI);
    disp(0);
    ready = 1;
    goto key;
  }

  getkeyrepeat(1000);
  goto key;

  exit:
  ngetchx();
  OSClearBreak();
  return;
}
